/*       -*- C++ -*- */
/** \file
 ********************************************************************
 * $URL: svn+ssh://nalw02/home/alg/schlemme/svn/cextools/trunk/include/cexfile/concept_label.h $
 * $Id: concept_label.h 12 2008-02-26 15:45:35Z schlemme $
 * $Date: 2008-02-26 16:45:35 +0100 (Di, 26 Feb 2008) $
 * $Revision: 12 $
 * \author Tobias Schlemmer <keinstein@users.berlios.de>
 * $Author: schlemme $ 
 * \license LGPL
 * 
 * Concept label class.
 ********************************************************************
 */	  
#ifndef CEXFILE_CONCEPT_LABEL_H
#define CEXFILE_CONCEPT_LABEL_H

#include "cexfile/label.h"
#include "cexfile/concept.h"

namespace cexfile {
  /// a single concept label
  class concept_label:protected label {
  public:
    /// default constructor
    concept_label():label(),id() {}

    /// standard constructor
    /** \param Node XML Node to be parsed 
     */
    concept_label(const xmlpp::Node * Node);
  };

  /// a concept label set mapping concept ids to labels
  typedef std::map<concept::idtype,concept_label> concept_label_s;

  /// add a concept label to the set of concept labesls
  /** \relates concept_label_s
      \relates concept_label
      \param s set of concept labels
      \param c concept label
  */
  inline concept_label_s& operator += (concept_label_s& s, 
					 const concept_label c) {
    s[c.get_id()]=c;
    return s;
  }

  inline concept_label::concept_label (const xmlpp::Node * Node)
    :label()
  {
    if (!Node) throw xmlpp::validity_error("Empty concept label node.");

#ifdef DEBUG
    std::cerr << "Concept Label: " << Node -> get_path() << std::endl;
#endif

    position = point(Node);
    id = parse_single_node_concept(Node,CONCEPT_REFERENCE,
				     ID_CONCEPT);
  }
}

#endif /* CEXFILE_CONCEPT_LABEL_H */
